/***************************************************************************
                          document.cpp  -  description
                             -------------------
    begin                : 2003-02-27
    copyright            : (C) 2000 by Bjrn Samvik
    email                : bjorn@samvik.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <Magick++.h>
#include <iostream>
#include <stdlib.h>
#include <fstream>
#include <string>

using namespace std;
using namespace Magick;

// Struktur fr calenderinforation
struct calInfo {
	string month;
	string year;
	string day_name[7];
	int start_day; // 0 = sndag, ..., 6 = lrdag
	int end_date; // Sista datumet dvs, 28, 30 eller 31;
};

// Funktionsdeklarationer
calInfo getCal(char *path);
string itos(int value);
calInfo startDayMa(calInfo cal);

// Main
int main(int argc, char *argv[]) {
	
	calInfo cal;
	
	int start_x = 100;
	int start_y = 100;
	int row = 0;
	int row_space = 30;
	int col_space = 35;
	
	Image image;
	
	cal = getCal(argv[1]);
	cal = startDayMa(cal); // Comment out this line to get Sunday as the first day of the week
	
	// Rita ut kalendern p bilden.
	image.read( argv[2] );
	image.font( "font/times.ttf" ); // To use another font change this line
	
	// Lista med alla prylar som ska ritas
	std::list<Magick::Drawable> drawList;
	
	// Ngra instllningar
	drawList.push_back( DrawablePointSize(20) );
	drawList.push_back( DrawableStrokeColor("black") );
	
	// Skriv ut mnad och r
	drawList.push_back( DrawableText(start_x, start_y, cal.month) );
	drawList.push_back( DrawableText(start_x + 3 * col_space, start_y, cal.year) );
	
	row++; // Ny rad
	
	// Skriv ut dagarnas namn
	drawList.push_back( DrawableStrokeColor("Blue") );
	for( int i = 0; i < 7; i++) {
		drawList.push_back( DrawableText(start_x + i * col_space, start_y + row * row_space, cal.day_name[i] ) );
	}
	
	row++; // Ny rad
	
	drawList.push_back( DrawableStrokeColor("red") );
	// Datumen
	int dag = 1;
	string t;
	int rows_tot = (2+((cal.end_date - ( 7 - cal.start_day)) / 7));
	
	for (int i = 0; i < rows_tot; i++) {
		if(row == 2) {
			for(int n = cal.start_day; n < 7; n++) {
				drawList.push_back( DrawableText(start_x + n * col_space, start_y + row * row_space, itos(dag)) );	
				dag++;
			}
		}
		else {
			for(int n = 0; n < 7; n++) {
				drawList.push_back( DrawableText(start_x + n * col_space, start_y + row * row_space, itos(dag)) );	
				dag++;
				
				if(dag > cal.end_date)
					break;
			}
		}
		row++;	
	}
	
	
	// Ritar
	image.draw( drawList ); 
	
	// Skriver till fil
	image.write( argv[3] );
		
	return 1;
}


// Hmtar information om kalendern.
calInfo getCal(char *path) {
	ifstream inFile;
	calInfo cal;
	string buff, buff2;
	int line = 0;
	
	inFile.open(path);
	
	while(getline(inFile, buff)) {
		if(line == 0) {
			for(unsigned int i = 0; i < buff.size(); i++) { // Loopa igenom buff
				if(buff.at(i) != ' ') {
					if(buff.at(i) >= '0' && buff.at(i) <= '9')
						cal.year += buff.at(i);
					else
						cal.month += buff.at(i);										
				}	
			}
		}
		
		else if(line == 1) {
			int day = 0; // Hller reda p villken dag vi jobbar med
			for(unsigned int i = 0; i < buff.size(); i++) { // Loopa igenom buff
				if(buff.at(i) != ' ') {
					cal.day_name[day] += buff.at(i);
					cal.day_name[day] += buff.at(i+1);
					i++;
					day++;					
				}
			}
		}
		
		else if(line == 2) {
			bool dig = false;
			int antal = 0;
			for(unsigned int i = 0; i < buff.size(); i++) { // Loopa igenom buff
				if(buff.at(i) != ' ') {
					dig = true;
				}
				else if (dig && buff.at(i) == ' ') {
					antal++;
					dig = false;
				}
			}

			if(dig)
				antal++;
			
			cal.start_day = 7 - antal;				
		
		
		}
		
		else if(line >= 6 && !buff.empty()) {
			char tmp[3];
			for(unsigned int i = 0; i < buff.size(); i++) { // Loopa igenom buff
				if(buff.at(i) != ' ') {
					tmp[0] = buff.at(i);
					tmp[1] = buff.at(i+1);
					tmp[2] = '\0';
					i++;
				}
			}
			cal.end_date = atoi(tmp);
		}
		
		line++;		
	}		
	inFile.close();
	
	return cal;
}


string itos(int value) {
	string ret;
	int tiotal;
	int heltal;
	
	tiotal = value/10;
	heltal = value - (tiotal*10);
	
	ret += (char)(tiotal + 48);
	ret += (char)(heltal + 48);
	
	return ret;
}


calInfo startDayMa(calInfo cal) {
	string tmp;
	
	if(cal.start_day - 1 < 0)
		cal.start_day = 6;
	else
		cal.start_day -= 1;
	
	
	tmp = cal.day_name[0]; // sparar undan
	
	for(int i = 0; i < 6; i++)
		cal.day_name[i] = cal.day_name[i+1];
	
	cal.day_name[6] = tmp;
	
	return cal;	
}
